﻿using AdventOfCode.Common;
using AdventOfCode.Models;
using System;
using System.Collections.Generic;
using System.Linq;

namespace AdventOfCode._2022
{
    [AOC(year: 2022, day: 1)]
    public class Day1 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var rows = GetSplitInput();
            var elves = new List<string[]>();
            int elfSet = 0;
            for (int i = 0; i < rows.Length; i++)
            {
                if (string.IsNullOrWhiteSpace(rows[i]))
                {
                    elves.Add(rows.Skip(elfSet).Take(i - elfSet).ToArray());
                    elfSet = i+1;
                }
                if (i == rows.Length-1)
                {
                    elves.Add(rows.Skip(elfSet).ToArray());
                }
            }
            var highestCalories = 0;
            foreach (var elf in elves)
            {
                highestCalories = Math.Max(highestCalories, elf.Select(x => int.Parse(x)).Sum());
            }

            _response.Answer = highestCalories;
            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var rows = GetSplitInput();
            var elves = new List<string[]>();
            int elfSet = 0;
            for (int i = 0; i < rows.Length; i++)
            {
                if (string.IsNullOrWhiteSpace(rows[i]))
                {
                    elves.Add(rows.Skip(elfSet).Take(i - elfSet).ToArray());
                    elfSet = i + 1;
                }
                if (i == rows.Length - 1)
                {
                    elves.Add(rows.Skip(elfSet).ToArray());
                }
            }
            var highestCalories = new List<int>();
            foreach (var elf in elves)
            {
                highestCalories.Add(elf.Select(x => int.Parse(x)).Sum());
            }
            _response.Answer = highestCalories.OrderByDescending(x => x).Take(3).Sum();
            return _response;
        }
    }
}
